IMPLEMENTATION MODULE TasteS;

FROM  TasteG  IMPORT 
  EOFSYM, identSym, numberSym, PROGRAMSym, semicolonSym, pointSym, VARSym, 
  colonSym, PROCEDURESym, BEGINSym, ENDSym, INTEGERSym, BOOLEANSym, equalSym, 
  IFSym, THENSym, ELSESym, WHILESym, DOSym, READSym, WRITESym, TRUESym, 
  FALSESym, minusSym, starSym, slashSym, plusSym, lessSym, greaterSym, NOSYM;

(* Scanner generated by Coco/R - assuming FileIO library will be available. *)

IMPORT FileIO, Storage;

CONST
  noSYMB  = NOSYM; (*error token code*)
  (* not only for errors but also for not finished states of scanner analysis *)
  eof     = 32C (* MS-DOS Keyboard eof char *);
  EOF     = FileIO.EOF;
  EOL     = FileIO.CR;
  CR      = FileIO.CR;
  LF      = FileIO.LF;
  Long0   = FileIO.Long0;
  Long1   = FileIO.Long1;
  BlkSize = 16384;
TYPE
  BufBlock   = ARRAY [0 .. BlkSize-1] OF CHAR;
  Buffer     = ARRAY [0 .. 31] OF POINTER TO BufBlock;
  StartTable = ARRAY [0 .. 255] OF INTEGER;
  GetCH      = PROCEDURE (INT32): CHAR;
VAR
  lastCh,
  ch:        CHAR;       (*current input character*)
  curLine:   INTEGER;    (*current input line (may be higher than line)*)
  lineStart: INT32;      (*start position of current line*)
  apx:       INT32;      (*length of appendix (CONTEXT phrase)*)
  oldEols:   INTEGER;    (*number of EOLs in a comment*)
  bp, bp0:   INT32;      (*current position in buf
                           (bp0: position of current token)*)
  LBlkSize:  INT32;      (*BlkSize*)
  inputLen:  INT32;      (*source file size*)
  buf:       Buffer;     (*source buffer for low-level access*)
  start:     StartTable; (*start state for every character*)
  CurrentCh: GetCH;

PROCEDURE ORDL (n: INT32): CARDINAL;
 BEGIN
   RETURN FileIO.ORDL(n)
 END ORDL;

PROCEDURE Err (nr, line, col: INTEGER; pos: INT32);
  BEGIN
    INC(errors)
  END Err;

PROCEDURE NextCh;
(* Return global variable ch *)
  BEGIN
    lastCh := ch; INC(bp); ch := CurrentCh(bp);
    IF (ch = EOL) OR (ch = FileIO.LF) AND (lastCh # EOL) THEN
      INC(curLine); lineStart := bp
    END
  END NextCh;

PROCEDURE Comment (): BOOLEAN;
  VAR
    level, startLine: INTEGER;
    oldLineStart: INT32;
  BEGIN
    level := 1; startLine := curLine; oldLineStart := lineStart;
    IF (ch = "(") THEN
      NextCh;
      IF (ch = "*") THEN
        NextCh;
        LOOP
          IF (ch = "*") THEN
            NextCh;
            IF (ch = ")") THEN
              DEC(level); NextCh;
              IF level = 0 THEN RETURN TRUE END
            END;
          ELSIF (ch = "(") THEN
            NextCh;
            IF (ch = "*") THEN INC(level); NextCh END;
          ELSIF ch = EOF THEN RETURN FALSE
          ELSE NextCh END;
        END; (* LOOP *)
      ELSE
        IF ch = EOL THEN DEC(curLine); lineStart := oldLineStart END;
        DEC(bp, 2); NextCh; RETURN FALSE
      END;
    END;RETURN FALSE;
  END Comment;

PROCEDURE Get (VAR sym: CARDINAL);
  VAR
    state: CARDINAL;

  PROCEDURE Equal (s: ARRAY OF CHAR): BOOLEAN;
    VAR
      i: CARDINAL;
      q: INT32;
    BEGIN
      IF nextLen # FileIO.SLENGTH(s) THEN RETURN FALSE END;
      i := 1; q := bp0; INC(q);
      WHILE i < nextLen DO
        IF CurrentCh(q) # s[i] THEN RETURN FALSE END;
        INC(i); INC(q)
      END;
      RETURN TRUE
    END Equal;

  PROCEDURE CheckLiteral;
    BEGIN
      CASE CurrentCh(bp0) OF
        "B": IF Equal("BEGIN") THEN sym := BEGINSym; 
             ELSIF Equal("BOOLEAN") THEN sym := BOOLEANSym; 
             END
      | "D": IF Equal("DO") THEN sym := DOSym; 
             END
      | "E": IF Equal("ELSE") THEN sym := ELSESym; 
             ELSIF Equal("END") THEN sym := ENDSym; 
             END
      | "F": IF Equal("FALSE") THEN sym := FALSESym; 
             END
      | "I": IF Equal("IF") THEN sym := IFSym; 
             ELSIF Equal("INTEGER") THEN sym := INTEGERSym; 
             END
      | "P": IF Equal("PROCEDURE") THEN sym := PROCEDURESym; 
             ELSIF Equal("PROGRAM") THEN sym := PROGRAMSym; 
             END
      | "R": IF Equal("READ") THEN sym := READSym; 
             END
      | "T": IF Equal("THEN") THEN sym := THENSym; 
             ELSIF Equal("TRUE") THEN sym := TRUESym; 
             END
      | "V": IF Equal("VAR") THEN sym := VARSym; 
             END
      | "W": IF Equal("WHILE") THEN sym := WHILESym; 
             ELSIF Equal("WRITE") THEN sym := WRITESym; 
             END
      ELSE
      END
    END CheckLiteral;

  BEGIN (*Get*)
    WHILE (ch=' ') OR
          (ch >= CHR(9)) & (ch <= CHR(10)) OR
          (ch = CHR(13)) DO NextCh END;
    IF ((ch = "(")) & Comment() THEN Get(sym); RETURN END;
    pos := nextPos;   nextPos := bp;
    col := nextCol;   nextCol := FileIO.INTL(bp - lineStart);
    line := nextLine; nextLine := curLine;
    len := nextLen;   nextLen := 0;
    apx := FileIO.Long0; state := start[ORD(ch)]; bp0 := bp;
    LOOP
      NextCh; INC(nextLen);
      CASE state OF
         1: IF (ch >= "0") & (ch <= "9") OR
               (ch >= "A") & (ch <= "Z") OR
               (ch >= "a") & (ch <= "z") THEN 
            ELSE sym := identSym; CheckLiteral; RETURN
            END;
      |  2: IF (ch >= "0") & (ch <= "9") THEN 
            ELSE sym := numberSym; RETURN
            END;
      |  3: sym := semicolonSym; RETURN
      |  4: sym := pointSym; RETURN
      |  5: sym := colonSym; RETURN
      |  6: sym := equalSym; RETURN
      |  7: sym := minusSym; RETURN
      |  8: sym := starSym; RETURN
      |  9: sym := slashSym; RETURN
      | 10: sym := plusSym; RETURN
      | 11: sym := lessSym; RETURN
      | 12: sym := greaterSym; RETURN
      | 13: sym := EOFSYM; ch := 0C; DEC(bp); RETURN
      ELSE sym := noSYMB; RETURN (*NextCh already done*)
      END
    END
  END Get;

PROCEDURE GetString (pos: INT32; len: CARDINAL; VAR s: ARRAY OF CHAR);
  VAR
    i: CARDINAL;
    p: INT32;
  BEGIN
    IF len > HIGH(s) THEN len := HIGH(s) END;
    p := pos; i := 0;
    WHILE i < len DO
      s[i] := CharAt(p); INC(i); INC(p)
    END;
    s[len] := 0C;
  END GetString;

PROCEDURE GetName (pos: INT32; len: CARDINAL; VAR s: ARRAY OF CHAR);
  VAR
    i: CARDINAL;
    p: INT32;
  BEGIN
    IF len > HIGH(s) THEN len := HIGH(s) END;
    p := pos; i := 0;
    WHILE i < len DO
      s[i] := CurrentCh(p); INC(i); INC(p)
    END;
    s[len] := 0C;
  END GetName;

PROCEDURE CharAt (pos: INT32): CHAR;
  VAR
    ch: CHAR;
  BEGIN
    IF pos >= inputLen THEN RETURN FileIO.EOF END;
    ch := buf[FileIO.ORDL(pos DIV LBlkSize)]^[FileIO.ORDL(pos MOD LBlkSize)];
    IF ch # eof THEN RETURN ch ELSE RETURN FileIO.EOF END
  END CharAt;

PROCEDURE CapChAt (pos: INT32): CHAR;
  VAR
    ch: CHAR;
  BEGIN
    IF pos >= inputLen THEN RETURN FileIO.EOF END;
    ch := CAP(buf[FileIO.ORDL(pos DIV LBlkSize)]^[FileIO.ORDL(pos MOD LBlkSize)]);
    IF ch # eof THEN RETURN ch ELSE RETURN FileIO.EOF END
  END CapChAt;

PROCEDURE Reset;
  VAR
    len: INT32;
    i, read: CARDINAL;
  BEGIN (*assert: src has been opened*)
    len := FileIO.Length(src); i := 0; inputLen := len;
    WHILE len > LBlkSize DO
      Storage.ALLOCATE(buf[i], BlkSize);
      read := BlkSize; FileIO.ReadBytes(src, buf[i]^, read);
      len := len - FileIO.INT(read); INC(i)
    END;
    Storage.ALLOCATE(buf[i], FileIO.ORDL(len) + 1);
    read := FileIO.ORDL(len); FileIO.ReadBytes(src, buf[i]^, read);
    buf[i]^[read] := EOF;
    curLine := 1; lineStart := -FileIO.Long2; bp := -FileIO.Long1;
    oldEols := 0; apx := FileIO.Long0; errors := 0;
    NextCh;
  END Reset;

BEGIN
  CurrentCh := CharAt;
  start[  0] := 13; start[  1] := 14; start[  2] := 14; start[  3] := 14; 
  start[  4] := 14; start[  5] := 14; start[  6] := 14; start[  7] := 14; 
  start[  8] := 14; start[  9] := 14; start[ 10] := 14; start[ 11] := 14; 
  start[ 12] := 14; start[ 13] := 14; start[ 14] := 14; start[ 15] := 14; 
  start[ 16] := 14; start[ 17] := 14; start[ 18] := 14; start[ 19] := 14; 
  start[ 20] := 14; start[ 21] := 14; start[ 22] := 14; start[ 23] := 14; 
  start[ 24] := 14; start[ 25] := 14; start[ 26] := 14; start[ 27] := 14; 
  start[ 28] := 14; start[ 29] := 14; start[ 30] := 14; start[ 31] := 14; 
  start[ 32] := 14; start[ 33] := 14; start[ 34] := 14; start[ 35] := 14; 
  start[ 36] := 14; start[ 37] := 14; start[ 38] := 14; start[ 39] := 14; 
  start[ 40] := 14; start[ 41] := 14; start[ 42] :=  8; start[ 43] := 10; 
  start[ 44] := 14; start[ 45] :=  7; start[ 46] :=  4; start[ 47] :=  9; 
  start[ 48] :=  2; start[ 49] :=  2; start[ 50] :=  2; start[ 51] :=  2; 
  start[ 52] :=  2; start[ 53] :=  2; start[ 54] :=  2; start[ 55] :=  2; 
  start[ 56] :=  2; start[ 57] :=  2; start[ 58] :=  5; start[ 59] :=  3; 
  start[ 60] := 11; start[ 61] :=  6; start[ 62] := 12; start[ 63] := 14; 
  start[ 64] := 14; start[ 65] :=  1; start[ 66] :=  1; start[ 67] :=  1; 
  start[ 68] :=  1; start[ 69] :=  1; start[ 70] :=  1; start[ 71] :=  1; 
  start[ 72] :=  1; start[ 73] :=  1; start[ 74] :=  1; start[ 75] :=  1; 
  start[ 76] :=  1; start[ 77] :=  1; start[ 78] :=  1; start[ 79] :=  1; 
  start[ 80] :=  1; start[ 81] :=  1; start[ 82] :=  1; start[ 83] :=  1; 
  start[ 84] :=  1; start[ 85] :=  1; start[ 86] :=  1; start[ 87] :=  1; 
  start[ 88] :=  1; start[ 89] :=  1; start[ 90] :=  1; start[ 91] := 14; 
  start[ 92] := 14; start[ 93] := 14; start[ 94] := 14; start[ 95] := 14; 
  start[ 96] := 14; start[ 97] :=  1; start[ 98] :=  1; start[ 99] :=  1; 
  start[100] :=  1; start[101] :=  1; start[102] :=  1; start[103] :=  1; 
  start[104] :=  1; start[105] :=  1; start[106] :=  1; start[107] :=  1; 
  start[108] :=  1; start[109] :=  1; start[110] :=  1; start[111] :=  1; 
  start[112] :=  1; start[113] :=  1; start[114] :=  1; start[115] :=  1; 
  start[116] :=  1; start[117] :=  1; start[118] :=  1; start[119] :=  1; 
  start[120] :=  1; start[121] :=  1; start[122] :=  1; start[123] := 14; 
  start[124] := 14; start[125] := 14; start[126] := 14; start[127] := 14; 
  start[128] := 14; start[129] := 14; start[130] := 14; start[131] := 14; 
  start[132] := 14; start[133] := 14; start[134] := 14; start[135] := 14; 
  start[136] := 14; start[137] := 14; start[138] := 14; start[139] := 14; 
  start[140] := 14; start[141] := 14; start[142] := 14; start[143] := 14; 
  start[144] := 14; start[145] := 14; start[146] := 14; start[147] := 14; 
  start[148] := 14; start[149] := 14; start[150] := 14; start[151] := 14; 
  start[152] := 14; start[153] := 14; start[154] := 14; start[155] := 14; 
  start[156] := 14; start[157] := 14; start[158] := 14; start[159] := 14; 
  start[160] := 14; start[161] := 14; start[162] := 14; start[163] := 14; 
  start[164] := 14; start[165] := 14; start[166] := 14; start[167] := 14; 
  start[168] := 14; start[169] := 14; start[170] := 14; start[171] := 14; 
  start[172] := 14; start[173] := 14; start[174] := 14; start[175] := 14; 
  start[176] := 14; start[177] := 14; start[178] := 14; start[179] := 14; 
  start[180] := 14; start[181] := 14; start[182] := 14; start[183] := 14; 
  start[184] := 14; start[185] := 14; start[186] := 14; start[187] := 14; 
  start[188] := 14; start[189] := 14; start[190] := 14; start[191] := 14; 
  start[192] := 14; start[193] := 14; start[194] := 14; start[195] := 14; 
  start[196] := 14; start[197] := 14; start[198] := 14; start[199] := 14; 
  start[200] := 14; start[201] := 14; start[202] := 14; start[203] := 14; 
  start[204] := 14; start[205] := 14; start[206] := 14; start[207] := 14; 
  start[208] := 14; start[209] := 14; start[210] := 14; start[211] := 14; 
  start[212] := 14; start[213] := 14; start[214] := 14; start[215] := 14; 
  start[216] := 14; start[217] := 14; start[218] := 14; start[219] := 14; 
  start[220] := 14; start[221] := 14; start[222] := 14; start[223] := 14; 
  start[224] := 14; start[225] := 14; start[226] := 14; start[227] := 14; 
  start[228] := 14; start[229] := 14; start[230] := 14; start[231] := 14; 
  start[232] := 14; start[233] := 14; start[234] := 14; start[235] := 14; 
  start[236] := 14; start[237] := 14; start[238] := 14; start[239] := 14; 
  start[240] := 14; start[241] := 14; start[242] := 14; start[243] := 14; 
  start[244] := 14; start[245] := 14; start[246] := 14; start[247] := 14; 
  start[248] := 14; start[249] := 14; start[250] := 14; start[251] := 14; 
  start[252] := 14; start[253] := 14; start[254] := 14; start[255] := 14; 
  Error := Err; LBlkSize := FileIO.INT(BlkSize); lastCh := EOF;
END TasteS.
